package edu.prlab.ecsimple.controller;

import edu.prlab.ecsimple.common.mapper.MapperUtil;
import edu.prlab.ecsimple.model.ResponseModel;
import edu.prlab.ecsimple.service.ProductService;
import edu.prlab.ecsimple.service.ProductServiceImpl;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequiredArgsConstructor
public class ProductController {

    private final ProductServiceImpl productService;

    @GetMapping("/product/{sku}")
    public ResponseEntity<ResponseModel> getProduct(@PathVariable Integer sku) {
        return productService.getProduct(sku)
                .map(MapperUtil::objectToJsonNode)
                .map(it -> ResponseEntity.ok()
                        .body(ResponseModel.builder()
                                .status("status")
                                .data(it)
                                .build()))
                .orElseGet(() -> ResponseEntity.notFound().build());
    }

    @GetMapping("/product")
    public ResponseEntity<ResponseModel> getProducts() {
        return ResponseEntity.ok()
                .body(ResponseModel.builder()
                .status("status")
                .data(MapperUtil.objectToJsonNode(productService.getProducts()))
                .build());
    }

//    @PostMapping("/checkout")
//    public ResponseEntity<ResponseModel> checkout(){
//        return
//    }
}